// PixelExporterDlg.cpp : implementation file

#include "stdafx.h"
#include "PixelExporter.h"
#include "PixelExporterDlg.h"
#include ".\pixelexporterdlg.h"
#include "Cswitch.h"
#include "statconnectorsrv.h"
#include "statconnectorcharacterdevice.h"
#include "DirectoryBrowse.h"
#include "SADirRead.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPixelExporterDlg dialog

CPixelExporterDlg::CPixelExporterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPixelExporterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPixelExporterDlg)
	m_DAT = _T("");
	m_DataPath = _T("");
	//m_GeneChip = _T("HG-U133A");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPixelExporterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPixelExporterDlg)
	DDX_Text(pDX, IDC_COMBO1, m_DAT);
	DDX_Text(pDX, IDC_DATA_PATH, m_DataPath);
	DDX_Text(pDX, IDC_EDIT17, m_GeneChip);
	DDX_Text(pDX, IDC_EDIT1, m_ProbeSet1);
	DDX_Text(pDX, IDC_EDIT2, m_ProbeSet2);
	DDX_Text(pDX, IDC_EDIT3, m_ProbeSet3);
	DDX_Text(pDX, IDC_EDIT4, m_ProbeSet4);
	DDX_Text(pDX, IDC_EDIT6, m_ProbeSet5);
	DDX_Text(pDX, IDC_EDIT5, m_ProbeSet6);
	DDX_Text(pDX, IDC_EDIT7, m_ProbeSet7);
	DDX_Text(pDX, IDC_EDIT8, m_ProbeSet8);
	DDX_Text(pDX, IDC_EDIT9, m_ProbeSet10);
	DDX_Text(pDX, IDC_EDIT10, m_ProbeSet9);
	DDX_Text(pDX, IDC_EDIT11, m_ProbeSet11);
	DDX_Text(pDX, IDC_EDIT12, m_ProbeSet12);
	//}}AFX_DATA_MAP
	
	DDX_Control(pDX, IDC_Probe_Sets, ProbeSets);
	DDX_Control(pDX, IDC_EDIT1, ProbeSet1);
	DDX_Control(pDX, IDC_EDIT2, ProbeSet2);
	DDX_Control(pDX, IDC_EDIT3, ProbeSet3);
	DDX_Control(pDX, IDC_EDIT4, ProbeSet4);
	DDX_Control(pDX, IDC_EDIT6, ProbeSet5);
	DDX_Control(pDX, IDC_EDIT5, ProbeSet6);
	DDX_Control(pDX, IDC_EDIT7, ProbeSet7);
	DDX_Control(pDX, IDC_EDIT8, ProbeSet8);
	DDX_Control(pDX, IDC_EDIT10, ProbeSet9);
	DDX_Control(pDX, IDC_EDIT9, ProbeSet10);
	DDX_Control(pDX, IDC_EDIT11, ProbeSet11);
	DDX_Control(pDX, IDC_EDIT12, ProbeSet12);
	DDX_Control(pDX, IDC_BUTTON13, Analyze);
	DDX_Control(pDX, IDC_EDIT13, est);
	DDX_Control(pDX, IDC_EDIT14, ci);
	DDX_Control(pDX, IDC_EDIT15, dfile);
	DDX_Control(pDX, IDC_EDIT16, Filename);
	DDX_Control(pDX, IDC_DATA_PATH, DataPath);
	DDX_Control(pDX, IDC_COMBO1, DATfiles);
	DDX_Control(pDX, IDC_EDIT17, GC);
}

BEGIN_MESSAGE_MAP(CPixelExporterDlg, CDialog)
	//{{AFX_MSG_MAP(CPixelExporterDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON5, OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON4, OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON6, OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON8, OnBnClickedButton8)
	ON_BN_CLICKED(IDC_BUTTON7, OnBnClickedButton7)
	ON_BN_CLICKED(IDC_BUTTON9, OnBnClickedButton9)
	ON_BN_CLICKED(IDC_BUTTON10, OnBnClickedButton10)
	ON_BN_CLICKED(IDC_BUTTON11, OnBnClickedButton11)
	ON_BN_CLICKED(IDC_BUTTON12, OnBnClickedButton12)
	ON_BN_CLICKED(IDC_BUTTON13, OnBnClickedButton13)
	ON_BN_CLICKED(IDC_BUTTON14, OnBnClickedButton14)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)

	ON_EN_CHANGE(IDC_EDIT17, OnEnChangeEdit17)
	ON_CBN_SELENDOK(IDC_COMBO1, OnCbnSelendokCombo1)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPixelExporterDlg message handlers

BOOL CPixelExporterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPixelExporterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPixelExporterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

extern CString ExportData(const char *, const char *, const char *, const char *, const char *, const char *,const char *, const char *, const char *,const char *, const char *, const char *,const char *, const char *, const char *);

void CPixelExporterDlg::OnOK() 
{
	UpdateData();
	CWaitCursor wait;
	CString filename=ExportData(m_DAT, m_DataPath, m_GeneChip,m_ProbeSet1,m_ProbeSet2,m_ProbeSet3,m_ProbeSet4,m_ProbeSet5,m_ProbeSet6,m_ProbeSet7,m_ProbeSet8,m_ProbeSet9,m_ProbeSet10,m_ProbeSet11,m_ProbeSet12);
	if(filename!="") AfxMessageBox("Export complete");
	else AfxMessageBox("Internal error");
}




void CPixelExporterDlg::OnBnClickedButton2()
{
	// transfer current list box selection to text box 1
	CString cursel;

	ProbeSets.GetText(ProbeSets.GetCurSel(), cursel);
	ProbeSet1.Clear();
	ProbeSet1.SetWindowText(cursel);
	cursel.Replace("_3_at","_5_at");
	ProbeSet7.Clear();
	ProbeSet7.SetWindowText(cursel);	
}


void CPixelExporterDlg::OnBnClickedButton3()
{
	// transfer current list box selection to text box 2
	CString cursel;

	ProbeSets.GetText(ProbeSets.GetCurSel(), cursel);
	ProbeSet2.Clear();
	ProbeSet2.SetWindowText(cursel);
	cursel.Replace("_3_at","_5_at");
	ProbeSet8.Clear();
	ProbeSet8.SetWindowText(cursel);
}

void CPixelExporterDlg::OnBnClickedButton5()
{
	// transfer current list box selection to text box 3
	CString cursel;

	ProbeSets.GetText(ProbeSets.GetCurSel(), cursel);
	ProbeSet3.Clear();
	ProbeSet3.SetWindowText(cursel);
	cursel.Replace("_3_at","_5_at");
	ProbeSet9.Clear();
	ProbeSet9.SetWindowText(cursel);
}

void CPixelExporterDlg::OnBnClickedButton4()
{
	// transfer current list box selection to text box 4
	CString cursel;

	ProbeSets.GetText(ProbeSets.GetCurSel(), cursel);
	ProbeSet4.Clear();
	ProbeSet4.SetWindowText(cursel);
	cursel.Replace("_3_at","_5_at");
	ProbeSet10.Clear();
	ProbeSet10.SetWindowText(cursel);
}

void CPixelExporterDlg::OnBnClickedButton1()
{
	// transfer current list box selection to text box 5
	CString cursel;

	ProbeSets.GetText(ProbeSets.GetCurSel(), cursel);
	ProbeSet5.Clear();
	ProbeSet5.SetWindowText(cursel);
	cursel.Replace("_3_at","_5_at");
	ProbeSet11.Clear();
	ProbeSet11.SetWindowText(cursel);
}

void CPixelExporterDlg::OnBnClickedButton6()
{
// transfer current list box selection to text box 6
	CString cursel;

	ProbeSets.GetText(ProbeSets.GetCurSel(), cursel);
	ProbeSet6.Clear();
	ProbeSet6.SetWindowText(cursel);
	cursel.Replace("_3_at","_5_at");
	ProbeSet12.Clear();
	ProbeSet12.SetWindowText(cursel);
}

void CPixelExporterDlg::OnBnClickedButton8()
{
	// clears text box 1 content
	ProbeSet1.Clear();
	ProbeSet1.SetWindowText("");
	ProbeSet7.Clear();
	ProbeSet7.SetWindowText("");
}

void CPixelExporterDlg::OnBnClickedButton7()
{
	// clears text box 2 content
	ProbeSet2.Clear();
	ProbeSet2.SetWindowText("");
	ProbeSet8.Clear();
	ProbeSet8.SetWindowText("");
}

void CPixelExporterDlg::OnBnClickedButton9()
{	
	// clears text box 3 content
	ProbeSet3.Clear();
	ProbeSet3.SetWindowText("");
	ProbeSet9.Clear();
	ProbeSet9.SetWindowText("");
}

void CPixelExporterDlg::OnBnClickedButton10()
{
	// clears text box 4 content
	ProbeSet4.Clear();
	ProbeSet4.SetWindowText("");
	ProbeSet10.Clear();
	ProbeSet10.SetWindowText("");
}

void CPixelExporterDlg::OnBnClickedButton11()
{
	// clears text box 5 content
	ProbeSet5.Clear();
	ProbeSet5.SetWindowText("");
	ProbeSet11.Clear();
	ProbeSet11.SetWindowText("");
}

void CPixelExporterDlg::OnBnClickedButton12()
{
	// clears text box 6 content
	ProbeSet6.Clear();
	ProbeSet6.SetWindowText("");
	ProbeSet12.Clear();
	ProbeSet12.SetWindowText("");
}

//Analyze only button
void CPixelExporterDlg::OnBnClickedButton13()
{	
	UpdateData();
	CWaitCursor wait;
	
	VARIANT estimate;
	VARIANT ciup;
	VARIANT cilow;
	CString dp;
	CString fn;
	Filename.GetWindowText(fn);
	
	if (fn == "")
	{
		AfxMessageBox("Specify exported text file for analysis!");
		
	}else
	{
	dp=m_DataPath;
	dp.Replace("\\","/");
	
	//performing analysis of extracted data
	IStatConnector lConnector;
	ASSERT(SUCCEEDED(lConnector.CreateDispatch(_T("StatConnectorSrv.StatConnector"))));
	lConnector.Init(_T("R"));
	lConnector.EvaluateNoReturn(_T("library(nlme)"));
	lConnector.EvaluateNoReturn(_T("setwd(\""+dp+"\")"));
	lConnector.EvaluateNoReturn(_T("vov2g<-read.table(\""+fn+"\",header=TRUE)"));
	lConnector.EvaluateNoReturn(_T("fit.lme<-lme(log2(Intensity)~as.factor(End)+logpgc-1,random=(~1|Probe/End/ProbeNo),method=\"REML\",data=vov2g,correlation=corCompSymm(form=~1|Probe/End/ProbeNo))"));
	lConnector.EvaluateNoReturn(_T("int<-intervals(fit.lme,which=\"fixed\")"));
	estimate=lConnector.Evaluate(_T("round(2^int$fixed[5],2)"));
	ciup=lConnector.Evaluate(_T("round(2^int$fixed[8],2)"));
	cilow=lConnector.Evaluate(_T("round(2^int$fixed[2],2)"));
	lConnector.Close();
	_bstr_t esti = estimate;
	est.SetWindowText(esti);
	_bstr_t ciu = ciup;
	_bstr_t cil = cilow;
	ci.SetWindowText("("+cil+","+ciu+")");
	dfile.SetWindowText(m_DAT);
	}
}
//Export and Analyze Button method
void CPixelExporterDlg::OnBnClickedButton14()
{	
	est.SetWindowText("");
	ci.SetWindowText("");
	dfile.SetWindowText("");
	UpdateData();
	est.SetWindowText("");
	ci.SetWindowText("");
	dfile.SetWindowText("");
	CWaitCursor wait;
	
	CString filename=ExportData(m_DAT, m_DataPath, m_GeneChip,m_ProbeSet1,m_ProbeSet2,m_ProbeSet3,m_ProbeSet4,m_ProbeSet5,m_ProbeSet6,m_ProbeSet7,m_ProbeSet8,m_ProbeSet9,m_ProbeSet10,m_ProbeSet11,m_ProbeSet12);
	if(filename!="no")
	{
	VARIANT estimate;
	VARIANT ciup;
	VARIANT cilow;
	CString dp;

	dp=m_DataPath;
	dp.Replace("\\","/");
	
	//performing analysis of extracted data
	IStatConnector lConnector;
	ASSERT(SUCCEEDED(lConnector.CreateDispatch(_T("StatConnectorSrv.StatConnector"))));
	lConnector.Init(_T("R"));
	lConnector.EvaluateNoReturn(_T("library(nlme)"));
	lConnector.EvaluateNoReturn(_T("setwd(\""+dp+"\")"));
	//lConnector.SetCharacterOutputDevice(m_GUILogDevice.GetCharDev());
	lConnector.EvaluateNoReturn(_T("vov2g<-read.table(\""+filename+".txt\",header=TRUE)"));
	lConnector.EvaluateNoReturn(_T("fit.lme<-lme(log2(Intensity)~End+logpgc,random=(~1|Probe/End/ProbeNo),method=\"REML\",data=vov2g,correlation=corCompSymm(form=~1|Probe/End/ProbeNo))"));
	lConnector.EvaluateNoReturn(_T("int<-intervals(fit.lme,which=\"fixed\")"));
	estimate=lConnector.Evaluate(_T("round(2^int$fixed[5],2)"));
	ciup=lConnector.Evaluate(_T("round(2^int$fixed[8],2)"));
	cilow=lConnector.Evaluate(_T("round(2^int$fixed[2],2)"));
	lConnector.Close();
	_bstr_t esti = estimate;
	est.SetWindowText(esti);
	_bstr_t ciu = ciup;
	_bstr_t cil = cilow;
	ci.SetWindowText("("+cil+","+ciu+")");
	dfile.SetWindowText(m_DAT);
	}
}

void CPixelExporterDlg::OnBrowse() 
{
	CDirectoryBrowse dlg;

	// set the initial directory
	dlg.SetInitDir("C:\\");

	// set the title of the dialog
	dlg.SetTitle("Select Your Data Directory");

	if(dlg.DoModal())
	{
		dlg.GetDirectory(m_directory);
		UpdateData(FALSE);
	}
	DataPath.SetWindowText(m_directory);
	DATfiles.ResetContent();
	CSADirRead dr;
	dr.GetDirs(m_directory, false);
	dr.GetFiles("*.DAT",true,false);
	CSADirRead::SAFileVector &fileVector = dr.Files();
	for (CSADirRead::SAFileVector::const_iterator fit = fileVector.begin(); fit!=fileVector.end(); fit++)
	{
		DATfiles.AddString((*fit).m_sName);
	}
	ProbeSets.ResetContent();
	GC.Clear();
	GC.SetWindowText("");

}

void CPixelExporterDlg::OnEnChangeEdit17()
{
	// TODO: Add your control notification handler code here
	CString strSelected;
	CWaitCursor wait;

	if( true )
	{
		//output the available probe sets
		//to add GeneChips, add cases to switch routine
		//to add probe sets, modify the cases of the switch routine
		GC.GetWindowText(strSelected);
		STR_SWITCH(strSelected)
		{
		STR_CASE_EXACT("HG-U133A")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-HUMISGF3A/M97935_3_at");
			ProbeSets.AddString("AFFX-HUMGAPDH/M33197_3_at");
			ProbeSets.AddString("AFFX-HSAC07/X00351_3_at");
			ProbeSets.AddString("AFFX-HUMRGE/M10098_3_at");
			ProbeSets.AddString("AFFX-M27830_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE_EXACT("HG-U133B")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-HUMISGF3A/M97935_3_at");
			ProbeSets.AddString("AFFX-HUMGAPDH/M33197_3_at");
			ProbeSets.AddString("AFFX-HSAC07/X00351_3_at");
			ProbeSets.AddString("AFFX-HUMRGE/M10098_3_at");
			ProbeSets.AddString("AFFX-M27830_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("Human Genome Arrays")
		{
			ProbeSets.ResetContent();
		}
		STR_CASE("Mouse Genome Arrays")
		{
			ProbeSets.ResetContent();
		}
		STR_CASE("Mouse430A_2")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-18SRNAMur/X00686_3_at");
			ProbeSets.AddString("AFFX-b-ActinMur/M12481_3_at");
			ProbeSets.AddString("AFFX-GapdhMur/M32599_3_at");
			ProbeSets.AddString("AFFX-PyruCarbMur/L09192_3_at");
			ProbeSets.AddString("AFFX-TransRecMur/X57349_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("HG-Focus")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-HSAC07/X00351_3_at");
			ProbeSets.AddString("AFFX-HUMGAPDH/M33197_3_at");
			ProbeSets.AddString("AFFX-HUMISGF3A/M97935_3_at");
			ProbeSets.AddString("AFFX-HUMRGE/M10098_3_at");
			ProbeSets.AddString("AFFX-M27830_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("Hu6800")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-HSAC07/X00351_3_at");
			ProbeSets.AddString("AFFX-HUMGAPDH/M33197_3_at");
			ProbeSets.AddString("AFFX-HUMISGF3A/M97935_3_at");
			ProbeSets.AddString("AFFX-HUMRGE/M10098_3_at");
			ProbeSets.AddString("AFFX-HUMTFRR/M11507_3_at");
			ProbeSets.AddString("AFFX-M27830_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("HC_G110")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-HSAC07/X00351_3_at");
			ProbeSets.AddString("AFFX-HUMGAPDH/M33197_3_at");
			ProbeSets.AddString("AFFX-HUMISGF3A/M97935_3_at");
			ProbeSets.AddString("AFFX-HUMRGE/M10098_3_at");
			ProbeSets.AddString("AFFX-HUMTFRR/M11507_3_at");
			ProbeSets.AddString("AFFX-M27830_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("HG-U133_Plus_2")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-HSAC07/X00351_3_at");
			ProbeSets.AddString("AFFX-HUMGAPDH/M33197_3_at");
			ProbeSets.AddString("AFFX-HUMISGF3A/M97935_3_at");
			ProbeSets.AddString("AFFX-HUMRGE/M10098_3_at");
			ProbeSets.AddString("AFFX-M27830_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("HG-U133A_2")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-HSAC07/X00351_3_at");
			ProbeSets.AddString("AFFX-HUMGAPDH/M33197_3_at");
			ProbeSets.AddString("AFFX-HUMISGF3A/M97935_3_at");
			ProbeSets.AddString("AFFX-HUMRGE/M10098_3_at");
			ProbeSets.AddString("AFFX-M27830_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("HG_U95B")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-HSAC07/X00351_3_at");
			ProbeSets.AddString("AFFX-HUMGAPDH/M33197_3_at");
			ProbeSets.AddString("AFFX-HUMISGF3A/M97935_3_at");
			ProbeSets.AddString("AFFX-HUMRGE/M10098_3_at");
			ProbeSets.AddString("AFFX-HUMTFRR/M11507_3_at");
			ProbeSets.AddString("AFFX-M27830_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("HG_U95Av2")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-HSAC07/X00351_3_at");
			ProbeSets.AddString("AFFX-HUMGAPDH/M33197_3_at");
			ProbeSets.AddString("AFFX-HUMISGF3A/M97935_3_at");
			ProbeSets.AddString("AFFX-HUMRGE/M10098_3_at");
			ProbeSets.AddString("AFFX-HUMTFRR/M11507_3_at");
			ProbeSets.AddString("AFFX-M27830_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("HG_U95C")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-HSAC07/X00351_3_at");
			ProbeSets.AddString("AFFX-HUMGAPDH/M33197_3_at");
			ProbeSets.AddString("AFFX-HUMISGF3A/M97935_3_at");
			ProbeSets.AddString("AFFX-HUMRGE/M10098_3_at");
			ProbeSets.AddString("AFFX-HUMTFRR/M11507_3_at");
			ProbeSets.AddString("AFFX-M27830_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("HG_U95D")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-HSAC07/X00351_3_at");
			ProbeSets.AddString("AFFX-HUMGAPDH/M33197_3_at");
			ProbeSets.AddString("AFFX-HUMISGF3A/M97935_3_at");
			ProbeSets.AddString("AFFX-HUMRGE/M10098_3_at");
			ProbeSets.AddString("AFFX-HUMTFRR/M11507_3_at");
			ProbeSets.AddString("AFFX-M27830_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("HG_U95E")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-HSAC07/X00351_3_at");
			ProbeSets.AddString("AFFX-HUMGAPDH/M33197_3_at");
			ProbeSets.AddString("AFFX-HUMISGF3A/M97935_3_at");
			ProbeSets.AddString("AFFX-HUMRGE/M10098_3_at");
			ProbeSets.AddString("AFFX-HUMTFRR/M11507_3_at");
			ProbeSets.AddString("AFFX-M27830_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("U133_X3P")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-HSAC07/X00351_3_at");
			ProbeSets.AddString("AFFX-HUMGAPDH/M33197_3_at");
			ProbeSets.AddString("AFFX-HUMISGF3A/M97935_3_at");
			ProbeSets.AddString("AFFX-HUMRGE/M10098_3_at");
			ProbeSets.AddString("AFFX-M27830_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("MOE430A")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-18SRNAMur/X00686_3_at");
			ProbeSets.AddString("AFFX-b-ActinMur/M12481_3_at");
			ProbeSets.AddString("AFFX-GapdhMur/M32599_3_at");
			ProbeSets.AddString("AFFX-PyruCarbMur/L09192_3_at");
			ProbeSets.AddString("AFFX-TransRecMur/X57349_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("MOE430B")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-18SRNAMur/X00686_3_at");
			ProbeSets.AddString("AFFX-b-ActinMur/M12481_3_at");
			ProbeSets.AddString("AFFX-GapdhMur/M32599_3_at");
			ProbeSets.AddString("AFFX-PyruCarbMur/L09192_3_at");
			ProbeSets.AddString("AFFX-TransRecMur/X57349_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("Mouse430_2")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-18SRNAMur/X00686_3_at");
			ProbeSets.AddString("AFFX-b-ActinMur/M12481_3_at");
			ProbeSets.AddString("AFFX-GapdhMur/M32599_3_at");
			ProbeSets.AddString("AFFX-PyruCarbMur/L09192_3_at");
			ProbeSets.AddString("AFFX-TransRecMur/X57349_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("Mu11KsubA")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-18SRNAMur/X00686_3_at");
			ProbeSets.AddString("AFFX-b-ActinMur/M12481_3_at");
			ProbeSets.AddString("AFFX-GapdhMur/M32599_3_at");
			ProbeSets.AddString("AFFX-PyruCarbMur/L09192_3_at");
			ProbeSets.AddString("AFFX-TransRecMur/X57349_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("Mu11KsubB")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-18SRNAMur/X00686_3_at");
			ProbeSets.AddString("AFFX-b-ActinMur/M12481_3_at");
			ProbeSets.AddString("AFFX-GapdhMur/M32599_3_at");
			ProbeSets.AddString("AFFX-PyruCarbMur/L09192_3_at");
			ProbeSets.AddString("AFFX-TransRecMur/X57349_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("MG_U74Av2")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-18SRNAMur/X00686_3_at");
			ProbeSets.AddString("AFFX-b-ActinMur/M12481_3_at");
			ProbeSets.AddString("AFFX-GapdhMur/M32599_3_at");
			ProbeSets.AddString("AFFX-PyruCarbMur/L09192_3_at");
			ProbeSets.AddString("AFFX-TransRecMur/X57349_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("MG_U74Bv2")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-18SRNAMur/X00686_3_at");
			ProbeSets.AddString("AFFX-b-ActinMur/M12481_3_at");
			ProbeSets.AddString("AFFX-GapdhMur/M32599_3_at");
			ProbeSets.AddString("AFFX-PyruCarbMur/L09192_3_at");
			ProbeSets.AddString("AFFX-TransRecMur/X57349_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_CASE("MG_U74Cv2")
		{
			ProbeSets.ResetContent();
			ProbeSets.AddString("AFFX-18SRNAMur/X00686_3_at");
			ProbeSets.AddString("AFFX-b-ActinMur/M12481_3_at");
			ProbeSets.AddString("AFFX-GapdhMur/M32599_3_at");
			ProbeSets.AddString("AFFX-PyruCarbMur/L09192_3_at");
			ProbeSets.AddString("AFFX-TransRecMur/X57349_3_at");
			ProbeSets.SetCurSel(0);
		}
		STR_SWITCH_END()
		}
	}
	UpdateData();
}

void CPixelExporterDlg::OnCbnSelendokCombo1()
{	// TODO: Add your control notification handler code here
	
	ProbeSet1.Clear();
	ProbeSet1.SetWindowText("");
	ProbeSet2.Clear();
	ProbeSet2.SetWindowText("");
	ProbeSet3.Clear();
	ProbeSet3.SetWindowText("");
	ProbeSet4.Clear();
	ProbeSet4.SetWindowText("");
	ProbeSet5.Clear();
	ProbeSet5.SetWindowText("");
	ProbeSet6.Clear();
	ProbeSet6.SetWindowText("");
	ProbeSet7.Clear();
	ProbeSet7.SetWindowText("");
	ProbeSet8.Clear();
	ProbeSet8.SetWindowText("");
	ProbeSet9.Clear();
	ProbeSet9.SetWindowText("");
	ProbeSet10.Clear();
	ProbeSet10.SetWindowText("");
	ProbeSet11.Clear();
	ProbeSet11.SetWindowText("");
	ProbeSet12.Clear();
	ProbeSet12.SetWindowText("");
	est.Clear();
	est.SetWindowText("");
	ci.Clear();
	ci.SetWindowText("");
	dfile.Clear();
	dfile.SetWindowText("");

	CString tDataPath;
	CWaitCursor wait;
	DataPath.GetWindowText(tDataPath);
	CString tDAT;
	int index = DATfiles.GetCurSel();
	this->DATfiles.GetLBText(index, tDAT);
		
	IGDACDATFilePtr pDatFile(CLSID_GDACDATFile);
	IGDACCDFFilePtr pCdfFile(CLSID_GDACCDFFile);
	IGDACProbeSetPtr pProbeSet(CLSID_GDACProbeSet);
	IGDACProbePairPtr pProbePair(CLSID_GDACProbePair);

	BSTR bstr = tDAT.AllocSysString();
	_bstr_t mDAT(bstr, FALSE);
	BSTR bstr2 = tDataPath.AllocSysString();
	_bstr_t mDP(bstr2, FALSE);
	const char *libPath=".\\CDF";
    pDatFile->Name = mDAT;
	pDatFile->DataPath = mDP;
	pDatFile->LibPath = libPath;
	pDatFile->ServerName = "";
	if (pDatFile->Exists() == FALSE)
	{
		AfxMessageBox("Image file does not exist!");
		return ;
	}
	pDatFile->Read();
	GC.SetWindowText(pDatFile->ChipType);
}
